#include <bits/stdc++.h>
using namespace std;

int numbers[501];
int sumsCountPoss[30001];
int sumsCountAnty[30001];

void generateSums(int sizeLine, int minNumber, int maxNumber)
{
    do
    {
       int currentSum=0;

       for(int index=0; index<sizeLine/2; index++)
       {
           currentSum+=numbers[index];

           if(currentSum>maxNumber)
           {
               break;
           }

           if(minNumber>currentSum)
           {
               continue;
           }

           if(currentSum>0)
           {
               sumsCountPoss[currentSum]++;
           }
           else
           {
               sumsCountAnty[abs(currentSum)]++;
           }
       }
    }
    while(next_permutation(numbers, numbers+sizeLine));
}


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int sizeLine, numberS, numberE;
    cin >> sizeLine >> numberS >> numberE;

    for(int index=0; index<sizeLine; index++)
    {
        cin >> numbers[index];
    }

    int maxSize=0;
    int currentSize=0;

    sort(numbers, numbers+sizeLine);

    generateSums(sizeLine, numberS, numberE);

    for(int currentNumber=numberS; currentNumber<=numberE; currentNumber++)
    {
        if(currentNumber>0 && sumsCountPoss[currentNumber]==0 || currentNumber<0 && sumsCountAnty[abs(currentNumber)]==0)
        {
            currentSize++;
        }
        else
        {
            maxSize=max(maxSize, currentSize);
            currentSize=0;
        }
    }

    maxSize=max(maxSize, currentSize);
    cout << maxSize;
    return 0;
}
