#include <bits/stdc++.h>
using namespace std;

vector<long> fibNumbers;
vector<long> prefix;

void generateFibs(const long maxNumber)
{
    fibNumbers.push_back(1);
    fibNumbers.push_back(2);

    prefix.push_back(1);
    prefix.push_back(3);

    int currentIndex=2;

    while(fibNumbers[currentIndex-2]+fibNumbers[currentIndex-1]<=maxNumber)
    {
        fibNumbers.push_back(fibNumbers[currentIndex-2]+fibNumbers[currentIndex-1]);
        prefix.push_back(prefix[currentIndex-1]+fibNumbers[currentIndex-2]+fibNumbers[currentIndex-1]);
        currentIndex++;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    long maxNumber;
    int sizeL;
    cin >> maxNumber >> sizeL;

    generateFibs(maxNumber);

    long long counter=0;

     for(int indexS=0; indexS<fibNumbers.size() && fibNumbers[indexS]*2<=maxNumber; indexS++)
    {
        long long currentSum;

        if(indexS==0)
        {
            currentSum=prefix[indexS+sizeL-3]-0;
        }
        else
        {
            currentSum=prefix[indexS+sizeL-3]-prefix[indexS-1];
        }

        if(currentSum*2>=maxNumber)
        {
            break;
        }

        long long currentStart=fibNumbers[indexS+sizeL-3];

        if(sizeL>3)
        {
            currentStart+=fibNumbers[indexS+sizeL-4];
        }
        else
        {
            currentStart++;
        }

        for(long finalNumber=currentStart; finalNumber<=maxNumber-currentSum; finalNumber++)
        {
            long long currentLast=maxNumber-currentSum-finalNumber;
            long long current=finalNumber+fibNumbers[indexS+sizeL-3];

            if(currentLast>=current)
            {
                counter++;
            }
            else
            {
                break;
            }
        }
    }

    cout << counter;
    return 0;
}
